		.h8300h
; ---------------------------------------------------------------------------- 
;  H8-300H ѥ饤֥  ֥                                          
;                                                  Copyright (C) 1998 by Ryuz  
; ---------------------------------------------------------------------------- 


		.include "3048.inc"


; ============================================
;                   
; ============================================

; -------------------------------------
;  ߶ػ
;  void di(void);
; -------------------------------------
		.section .text
		.global	_di
_di:		
		orc	#0x80,ccr
		rts

; -------------------------------------
;  ߵ
;  void ei(void);
; -------------------------------------
		.section .text
		.global	_ei
_ei:		
		andc	#0x7f,ccr
		rts

; -------------------------------------
;  ccr 
;  void load_ccr(unsigned char newccr);
; -------------------------------------
; unsigned char newccr : r0l
;
		.section .text
		.global	_load_ccr
_load_ccr:
		ldc	r0l,ccr
		rts

; -------------------------------------
;  ccr ȥ
;  unsigned char store_ccr(void);
; -------------------------------------
		.section .text
		.global	_store_ccr
_store_ccr:	
		stc	ccr,r0l
		mov.b	#0,r0h		; ǰΤ
		rts



; -------------------------------------
;  
;  void Wait(unsigned long tm);
; ꥢ16bit 2stateCPU 16MHz
; tm * 500ns + 2,000ns 
; (8bitХ tm * 875ns + 3,875ns)
; -------------------------------------
		.section .text
		.global	_Wait		; state8bitХΤȤ
_Wait:					; 12(24) state (jsr)
;;;		mov.l	@(4, er7),er0	; 10(20) state
wait1m_loop:	
		nop			;  2(4) state ׻䤹褦 (^^;
		dec.l	#1,er0		;  2(4) state
		bne	wait1m_loop	;  4(6) state
		
		rts			; 10(18) state




; ============================================
;                  SCI0
; ============================================

; Хåե
		.equ	SCI0_RBUF_SIZE, 64	; SCIͥ0μХåե
		.equ	SCI0_SBUF_SIZE, 64	; SCIͥ0Хåե

; -------------------------------------
;  SCI0 
;  void SCI0_Init(unsigned char brr);
; -------------------------------------
		.section .text
		.global	_SCI0_Init
_SCI0_Init:	
		mov.b	#0,r0h
		mov.b	r0h,@sci0_rptr_st
		mov.b	r0h,@sci0_rptr_ed
		mov.b	r0h,@sci0_sptr_st
		mov.b	r0h,@sci0_sptr_ed
		
		mov.b	r0h,@SCR0	;TE=0, RE=0, CKE1=0, CKE0=0
		mov.b	r0h,@SMR0	;SMR=00000000 (n=0)
;
		mov.b	r0l,@BRR0
		mov.w	#280,r0
sci0_ini_wai:
		dec.w	#1,r0
		bne	sci0_ini_wai
		mov.b	#0b01110000,r0l
		mov.b	r0l,@SCR0	;SCR=01110000 (RIE=1,TE=1,RE=1)
		rts

; -------------------------------------
;  SCI0 ѽλ
;  void SCI0_Close(void);
; -------------------------------------
		.section .text
		.global	_SCI0_Close
_SCI0_Close:	
		mov.b	#0,r0l
		mov.b	r0l,@SCR0
		rts

; -------------------------------------
;  SCI0 顼ߥϥɥ
;  void SCI0_Int_Err(void);
; -------------------------------------
		.section .text
		.global	_SCI0_Int_Err
_SCI0_Int_Err:	
		bclr	#5,@SSR0:8	;stop interrupt
		bclr	#4,@SSR0:8	;stop interrupt
		rts


; -------------------------------------
;  SCI0 ߥϥɥ
;  void _SCI0_Int_Char(void);
; -------------------------------------
		.section .text
		.global	_SCI0_Int_Char
_SCI0_Int_Char:	
		bclr.b	#6,@SSR0:8	; ե饰ꥢ
		mov.b	@RDR0,r2l	; 
		
		andc	#0b01111111,ccr	; ¿ųߤ
		
		xor.l	er0,er0
		mov.b	@sci0_rptr_ed,r0l
		mov.b	r0l,r1h
		inc.b	r1h
		cmp.b	#SCI0_RBUF_SIZE,r1h
		bcs	sci0_set_buf
		mov.b	#0,r1h
sci0_set_buf:	
		mov.b	@sci0_rptr_st,r1l
		cmp.b	r1l,r1h
		beq	end_sci0_ic	; ХåեäѤ
		
		mov.b	r2l,@(sci0_rbuf, er0)
		mov.b	r1h,@sci0_rptr_ed
end_sci0_ic:	
		rts


; -------------------------------------
;  SCI0 ʸ
;  int SCI0_Getc(void);
; -------------------------------------
		.section .text
		.global	_SCI0_Getc
_SCI0_Getc:	
		xor.l	er1,er1
		mov.b	@sci0_rptr_st,r1l
		mov.b	@sci0_rptr_ed,r2l
		cmp.b	r1l,r2l
		beq	sci0_getc_nb	; Хåեʸ뤫
		
		xor.w	r0,r0
		mov.b	@(sci0_rbuf, er1), r0l	; ʸФ
		
		inc	r1l
		cmp.b	#SCI0_RBUF_SIZE, r1l
		bcs	sci0_getc_stpt
		mov.b	#0, r1l
sci0_getc_stpt:	
		mov.b	r1l,@sci0_rptr_st
		rts
		
sci0_getc_nb:	; ʸʤ
		mov.w	#0xffff,r0
		rts


; -------------------------------------
;  SCI0 Хåե
;  void SCI0_Int_Empty(void);
; -------------------------------------
		.section .text
		.global	_SCI0_Int_Empty
_SCI0_Int_Empty:
		bclr.b	#7,@SCR0:8	; ߤߤ
		
		ldc	#0x00,ccr	; ¿ųߤ
		
		xor.l	er0,er0
		mov.b	@sci0_sptr_st,r0l
		mov.b	@sci0_sptr_ed,r1l
		cmp.b	r0l,r1l		; ХåեʸϤ뤫
		bne	sci0_send_char
		rts		; Хåեʤ꥿
sci0_send_char:	
		mov.b	@(sci0_sbuf, er0), r2l
		mov.b	r2l,@TDR0	; ʸ
		bclr.b	#7,@SSR0:8
		
		inc.b	r0l
		cmp.b	#SCI0_SBUF_SIZE, r0l
		bcs	sci0_stptr
		mov.b	#0,r0l
sci0_stptr:	
		ldc	#0xff,ccr		; ¿ųߤػ
		mov.b	r0l,@sci0_sptr_st
		mov.b	@sci0_sptr_ed,r1l	; ¿ųߤǤѹθ
		cmp.b	r0l,r1l
		beq	sci0_emp_end
		
		bset.b	#7,@SCR0:8	; ޤʸгߵ
sci0_emp_end:	
		rts


; -------------------------------------
;  SCI0 ʸ
;  void SCI0_Petc(char c);
; -------------------------------------
		.section .text
		.global	_SCI0_Putc
_SCI0_Putc:	
		mov.b	r0l,r2l
		xor.l	er0,er0
		mov.b	@sci0_sptr_ed,r0l
		mov.b	@sci0_sptr_st,r1l
		cmp.b	r0l,r1l		; Хåե϶
		bne	sci0_chk_sbuf
		btst.b	#7,@SSR0:8	; ǽ
		beq	sci0_chk_sbuf
		
		mov.b	r2l,@TDR0	; Хåեǽʤ
		bclr.b	#7,@SSR0:8	; Τޤ
		rts
sci0_chk_sbuf:	
		mov.b	r0l,r1h
		inc.b	r1h
		cmp.b	#SCI0_SBUF_SIZE,r1h
		bcs	sci0_wai_sbuf
		mov.b	#0,r1h
sci0_wai_sbuf:	
		cmp.b	r1h, r1l
		bne	sci0_set_sbuf
		mov.b	@sci0_sptr_st,r1l
		bset.b	#7,@SCR0:8
		bra	sci0_wai_sbuf	; ХåեޤԤ
sci0_set_sbuf:	
		mov.b	r2l,@(sci0_sbuf, er0)
		mov.b	r1h,@sci0_sptr_ed
		
		bset.b	#7,@SCR0:8	; ߵ

		rts


; -------------------------------------
;  SCI0 ʸ(ݡ)
;  void SCI0_PetcP(char c);
; -------------------------------------
		.section .text
		.global	_SCI0_PutcP
_SCI0_PutcP:	
sci0_pp_wai:	
		btst.b	#7,@SSR0:8	; TEST TDRE
		beq	sci0_pp_wai	; WAIT IF TDRE=0
		mov.b	r0l,@TDR0	; WRITE DATA TO TRD
		bclr.b	#7,@SSR0:8	; CLEAR TDRE
		rts


; -------------------------------------
;  SCI0ǡ
; -------------------------------------
		.section .data
sci0_rptr_st:	.byte	0
sci0_rptr_ed:	.byte	0
sci0_rbuf:	.space	SCI0_RBUF_SIZE

		.section .data
sci0_sptr_st:	.byte	0
sci0_sptr_ed:	.byte	0
sci0_sbuf:	.space	SCI0_SBUF_SIZE




; ============================================
;                  SCI1
; ============================================

; Хåե
		.equ	SCI1_RBUF_SIZE, 64	; SCIͥ1μХåե
		.equ	SCI1_SBUF_SIZE, 64	; SCIͥ1Хåե

; -------------------------------------
;  SCI1 
;  void SCI1_Init(unsigned char brr);
; -------------------------------------
		.section .text
		.global	_SCI1_Init
_SCI1_Init:	
		mov.b	#0,r0h
		mov.b	r0h,@sci1_rptr_st
		mov.b	r0h,@sci1_rptr_ed
		mov.b	r0h,@sci1_sptr_st
		mov.b	r0h,@sci1_sptr_ed
		
		mov.b	r0h,@SCR1	;TE=0, RE=0, CKE1=0, CKE0=0
		mov.b	r0h,@SMR1	;SMR=00000000 (n=0)
		mov.b	r0l,@BRR1
		mov.w	#280,r0
sci1_ini_wai:
		dec.w	#1,r0
		bne	sci1_ini_wai
		mov.b	#0x70,r0l
		mov.b	r0l,@SCR1	;SCR=01110000 (RIE=1,TE=1,RE=1)
		rts

; -------------------------------------
;  SCI1 ѽλ
;  void SCI1_Close(void);
; -------------------------------------
		.section .text
		.global	_SCI1_Close
_SCI1_Close:	
		mov.b	#0,r0l
		mov.b	r0l, @SCR1
		rts

; -------------------------------------
;  SCI1 顼ߥϥɥ
;  void SCI1_Int_Err(void);
; -------------------------------------
		.section .text
		.global	_SCI1_Int_Err
_SCI1_Int_Err:	
		bclr	#5,@SSR1:8	;stop interrupt
		bclr	#4,@SSR1:8	;stop interrupt
		rts


; -------------------------------------
;  SCI1 ߥϥɥ
;  void _SCI1_Int_Char(void);
; -------------------------------------
		.section .text
		.global	_SCI1_Int_Char
_SCI1_Int_Char:	
		bclr.b	#6,@SSR1:8	; ե饰ꥢ
		mov.b	@RDR1,r2l	; 
		
		andc	#0b01111111,ccr	; ¿ųߤ
		
		xor.l	er0,er0
		mov.b	@sci1_rptr_ed,r0l
		mov.b	r0l,r1h
		inc.b	r1h
		cmp.b	#SCI1_RBUF_SIZE,r1h
		bcs	sci1_set_buf
		mov.b	#0,r1h
sci1_set_buf:	
		mov.b	@sci1_rptr_st,r1l
		cmp.b	r1l,r1h
		beq	end_sci1_ic	; ХåեäѤ
		
		mov.b	r2l,@(sci1_rbuf, er0)
		mov.b	r1h,@sci1_rptr_ed
end_sci1_ic:	
		rts


; -------------------------------------
;  SCI1 ʸ
;  int SCI1_Getc(void);
; -------------------------------------
		.section .text
		.global	_SCI1_Getc
_SCI1_Getc:	
		xor.l	er1,er1
		mov.b	@sci1_rptr_st,r1l
		mov.b	@sci1_rptr_ed,r2l
		cmp.b	r1l,r2l
		beq	sci1_getc_nb	; Хåեʸ뤫
		
		xor.w	r0,r0
		mov.b	@(sci1_rbuf, er1), r0l	; ʸФ
		
		inc	r1l
		cmp.b	#SCI1_RBUF_SIZE, r1l
		bcs	sci1_getc_stpt
		mov.b	#0, r1l
sci1_getc_stpt:	
		mov.b	r1l,@sci1_rptr_st
		rts
		
sci1_getc_nb:	; ʸʤ
		mov.w	#0xffff,r0
		rts


; -------------------------------------
;  SCI1 Хåե
;  void SCI1_Int_Empty(void);
; -------------------------------------
		.section .text
		.global	_SCI1_Int_Empty
_SCI1_Int_Empty:
		bclr.b	#7,@SCR1:8	; ߤߤ
		
		ldc	#0x00,ccr	; ¿ųߤ
		
		xor.l	er0,er0
		mov.b	@sci1_sptr_st,r0l
		mov.b	@sci1_sptr_ed,r1l
		cmp.b	r0l,r1l		; ХåեʸϤ뤫
		bne	sci1_send_char
		rts		; Хåեʤ꥿
sci1_send_char:	
		mov.b	@(sci1_sbuf, er0), r2l
		mov.b	r2l,@TDR1	; ʸ
		bclr.b	#7,@SSR1:8
		
		inc.b	r0l
		cmp.b	#SCI1_SBUF_SIZE, r0l
		bcs	sci1_stptr
		mov.b	#0,r0l
sci1_stptr:	
		ldc	#0xff,ccr		; ¿ųߤػ
		mov.b	r0l,@sci1_sptr_st
		mov.b	@sci1_sptr_ed,r1l	; ¿ųߤǤѹθ
		cmp.b	r0l,r1l
		beq	sci1_emp_end
		
		bset.b	#7,@SCR1:8	; ޤʸгߵ
sci1_emp_end:	
		rts


; -------------------------------------
;  SCI1 ʸ
;  void SCI1_Petc(char c);
; -------------------------------------
		.section .text
		.global	_SCI1_Putc
_SCI1_Putc:	
		mov.b	r0l,r2l
		xor.l	er0,er0
		mov.b	@sci1_sptr_ed,r0l
		mov.b	@sci1_sptr_st,r1l
		cmp.b	r0l,r1l		; Хåե϶
		bne	sci1_chk_sbuf
		btst.b	#7,@SSR1:8	; ǽ
		beq	sci1_chk_sbuf
		
		mov.b	r2l,@TDR1	; Хåեǽʤ
		bclr.b	#7,@SSR1:8	; Τޤ
		rts
sci1_chk_sbuf:	
		mov.b	r0l,r1h
		inc.b	r1h
		cmp.b	#SCI1_SBUF_SIZE,r1h
		bcs	sci1_wai_sbuf
		mov.b	#0,r1h
sci1_wai_sbuf:	
		cmp.b	r1h, r1l
		bne	sci1_set_sbuf
		mov.b	@sci1_sptr_st,r1l
		bset.b	#7,@SCR1:8
		bra	sci1_wai_sbuf	; ХåեޤԤ
sci1_set_sbuf:	
		mov.b	r2l,@(sci1_sbuf, er0)
		mov.b	r1h,@sci1_sptr_ed
		
		bset.b	#7,@SCR1:8	; ߵ

		rts


; -------------------------------------
;  SCI1 ʸ(ݡ)
;  void SCI1_PetcP(char c);
; -------------------------------------
		.section .text
		.global	_SCI1_PutcP
_SCI1_PutcP:	
sci1_pp_wai:	
		btst.b	#7,@SSR1:8	; TEST TDRE
		beq	sci1_pp_wai	; WAIT IF TDRE=0
		mov.b	r0l,@TDR1	; WRITE DATA TO TRD
		bclr.b	#7,@SSR1:8	; CLEAR TDRE
		rts


; -------------------------------------
;  SCI1ǡ
; -------------------------------------
		.section .data
sci1_rptr_st:	.byte	0
sci1_rptr_ed:	.byte	0
sci1_rbuf:	.space	SCI1_RBUF_SIZE

		.section .data
sci1_sptr_st:	.byte	0
sci1_sptr_ed:	.byte	0
sci1_sbuf:	.space	SCI1_SBUF_SIZE


		.end
